import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;

/**
 * Counter that displays a number and a target.
 * 
 * @author Ninto (original by Michael Kolling).
 * @version 0.1
 */
public class Counter extends superClass
{
    private Color textColor;
    private int value = 0;
    private int target = 0;
    private int stringLength;
    
    /**
     * Creates an counter with a color and a food target.
     */
    public Counter(Color myColor, int myTarget)
    {
        target = myTarget;
        textColor = myColor;
        setImage(new GreenfootImage(65, 32));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        Font font = image.getFont();
        font = font.deriveFont(20f);
        image.setFont(font);
        updateImage();
    }
    
    /**
     * Set the value to be drawn.
     */
    public void setValue(int value)
    {
        this.value = value;
        updateImage();
    }
    
    public int getValue() {
        return value;
    }
    
    /**
     * Make the image
     */
    private void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(value +"/"+ target, 1, 15);
    }
}