import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A pumpkin.
 * 
 * @author Ninto.
 * @version 0.1
 */
public class Pumpkin  extends Food
{
    private final static int maxPieces = 6;
    int piecesLeft = maxPieces;
    
    private static GreenfootImage[] pumpkin = new GreenfootImage[6];
    
    /**
     * Loads the "pumpkin"-images, and set the size of the pumpkin.
     */
    public Pumpkin(int pieces)
    {
        if(pumpkin[0] == null) {
            pumpkin[0] = new GreenfootImage("pumpkinPieces-5.png");
            pumpkin[1] = new GreenfootImage("pumpkinPieces-4.png");
            pumpkin[2] = new GreenfootImage("pumpkinPieces-3.png");
            pumpkin[3] = new GreenfootImage("pumpkinPieces-2.png");
            pumpkin[4] = new GreenfootImage("pumpkinPieces-1.png");
            pumpkin[5] = new GreenfootImage("pumpkin.png");
        }
        if(pieces >= maxPieces) {
            piecesLeft = maxPieces;
            setImage(pumpkin[piecesLeft-1]);
            return;
        }
        piecesLeft = pieces;
        setImage(pumpkin[piecesLeft-1]);
    }
    
    /**
     * Act - do whatever the Pumpkin wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if(piecesLeft <= 0) {
            getWorld().removeObject(this);
            return;
        }
        setImage(pumpkin[piecesLeft-1]);
    }
}