import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;

/**
 * Just a menu.
 * 
 * @author Ninto
 * @version 0.2
 */
public class menu  extends Actor
{
    private int zeroX, zeroY;
    private int mouseX, mouseY;
    private int myScene = 1;
    private boolean dragging;
    
    private static GreenfootImage[] img = new GreenfootImage[10];
    
    /**
     * creates a menu.
     */
    public menu()
    {
        if(img[0] != null) return;
        for(int i=0; i<10; i++) {
            img[i] = new GreenfootImage("menu.png");
            if(i==0) {
                img[i].drawString("xtra", 75, 39);
            }
            else {
                Font font = img[i].getFont();
                font = font.deriveFont(20.0f);
                img[i].setFont(font);
                img[i].drawString(""+i, 81, 42);
            }
        }
        setImage(img[1]);
    }
    
    /**
     * Act - do whatever the menu wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        setImage(img[myScene]);
        zeroX = getX()-getImage().getWidth()/2;
        zeroY = getY()-getImage().getHeight()/2;
        if(Greenfoot.getMouseInfo() != null) {
            mouseX = Greenfoot.getMouseInfo().getX();
            mouseY = Greenfoot.getMouseInfo().getY();
        }
        if(dragging) {
            if(Greenfoot.mouseClicked(null)) {dragging = false; return;}
            setLocation(mouseX+7, mouseY+getImage().getHeight()/2-5);
            return;
        }
        if(Greenfoot.mousePressed(this)) useMouseInfo();
    }
    
    /**
     * check if theres anything to click on at the location of the mouse.
     */
    private void useMouseInfo()
    {
        if(myScene > 0 && mouseX < zeroX+75 && mouseX > zeroX+64 && mouseY < zeroY+48 && mouseY > zeroY+21) myScene--; //arrow left
        if(myScene < 9 && mouseX < zeroX+111 && mouseX > zeroX+100 && mouseY < zeroY+48 && mouseY > zeroY+21) myScene++; //arrow right
        
        if(mouseX < zeroX+18 && mouseX > zeroX+10 && mouseY < zeroY+13 && mouseY > zeroY+5) {getWorld().removeObject(this); return;} //close menu
        if(mouseX < zeroX+165 && mouseX > 6 && mouseY < zeroY+15 && mouseY > 3) dragging = true; //drag the menu
        
        if(myScene != ((myWorld)getWorld()).sceneNum && mouseX < zeroX+78 && mouseX > zeroX+20 && mouseY < zeroY+73 && mouseY > zeroY+54)
        ((myWorld)getWorld()).buildScene(myScene); //'Play' pressed
        
        if(mouseX < zeroX+152 && mouseX > zeroX+96 && mouseY < zeroY+73 && mouseY > zeroY+54)
        ((myWorld)getWorld()).buildScene(((myWorld)getWorld()).sceneNum); //'Reset' pressed
    }
}