import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * The dry, dry beach/desert where the only things to grow is tomatos and pumpkins.
 * 
 * @author Ninto.
 * @version 0.1
 */
public class myWorld  extends World
{
    int sceneNum;
    boolean finished;
    private int tick;
    private int prevTime;
    private menu Menu = new menu();
    private Counter timer = new Counter(Color.BLACK, 60);
    
    private static GreenfootImage[] BG = new GreenfootImage[6];
    
    /**
     * When this constructer is called it will call the buildScene(1) method.
     */
    public myWorld() {
        super(640, 480, 1);
        Greenfoot.setSpeed(50);
        if(BG[0] == null) {
            for(int i=0; i<4; i++) BG[i] = new GreenfootImage("BG"+(i+1)+".jpg");
            BG[4] = new GreenfootImage(getWidth(), getHeight());
            BG[4].fill();
            BG[4].setColor(Color.WHITE);
            BG[4].drawString("Not made yet!", getWidth()/2-50, 50);
            BG[5] = new GreenfootImage(getWidth(), getHeight());
            BG[5].fill();
            BG[5].setColor(Color.RED);
            BG[5].drawString("OUT OF BOUND", getWidth()/2-50, 50);
        }
        setPaintOrder(menu.class, Counter.class, dictBG.class, Ship.class, Greep.class, rock.class, Food.class, tomatoPlant.class, effect.class);
        buildScene(1);
        addObject(Menu, 100, 419);
    }
    
    /**
     * Remove all objects added to the world.
     */
    public void removeAll() {
        removeObjects(getObjects(superClass.class));
    }
    
    /**
     * Builds the scenes.
     */
    public void buildScene(int scene) {
        removeAll();
        timer.setValue(0);
        finished = false;
        switch(scene) {
            case 0: {
                setBackground(BG[2]);
                addObject(new dictBG(), getWidth()/2, getHeight()/2);
            }break;
            case 1: scene1(); break;
            case 2: scene2(); break;
            case 3: scene3(); break;
            case 4: scene4(); break;
            default: if(scene > 9 || scene < 0) setBackground(BG[5]); else setBackground(BG[4]);
        }
        sceneNum = scene;
    }
    
    private void scene1() {
        addObject(timer, 580, 470);
        setBackground(BG[0]);
        addObject(new Ship(10, 2, 0, 0, 12, Color.RED), 100, 100);
        addObject(new Ship(10, 2, 0, 0, 12, Color.GRAY), 539, 379);
        for(int i=0; i<3; i++) addObject(new rock(), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
        for(int i=0; i<4; i++) addObject(new Pumpkin(6), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
        for(int i=0; i<12; i++) addObject(new tomatoPlant(), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
    }
    
    private void scene2() {
        addObject(timer, 580, 470);
        setBackground(BG[1]);
        addObject(new Ship(20, 10, 5, 2, 50, Color.RED), 111, 111);
        addObject(new Ship(10, 20, 5, 2, 50, Color.GRAY), 222, 222);
        addObject(new Ship(10, 10, 10, 2, 50, Color.GREEN), 333, 333);
        for(int i=0; i<3; i++) addObject(new rock(), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
        for(int i=0; i<2; i++) addObject(new Pumpkin(6), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
        for(int i=0; i<10; i++) addObject(new tomatoPlant(), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
        for(int i=0; i<50; i++) addObject(new Food(), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
    }
    
    private void scene3() {
        addObject(timer, 580, 470);
        setBackground(BG[3]);
        for(int i=0; i<3; i++) addObject(new rock(), Greenfoot.getRandomNumber(640), Greenfoot.getRandomNumber(480));
        for(int i=0; i<Greenfoot.getRandomNumber(5)+2; i++) {
            addObject(new Ship(Greenfoot.getRandomNumber(10)+1, Greenfoot.getRandomNumber(10)+1,
            Greenfoot.getRandomNumber(10)+1, Greenfoot.getRandomNumber(10)+1,
            Greenfoot.getRandomNumber(10)+20, getRandomColor()),
            Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight()));
        }
        for(int i=0; i<Greenfoot.getRandomNumber(100)+50; i++)
        switch(Greenfoot.getRandomNumber(3)) {
            case 0: addObject(new Food(), Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight())); break;
            case 1: if(Greenfoot.getRandomNumber(5)==0) addObject(new Pumpkin(6), Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight())); break;
            case 2: addObject(new tomatoPlant(), Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight())); break;
        }   
    }
    
    private void scene4() {
        buildScene(2);
        removeObjects(getObjects(Pumpkin.class));
        removeObjects(getObjects(Food.class));
        for(int i=0; i<10; i++)
        addObject(new rock(), Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight()));
    }
    
    /**
     * open a new menu.
     */
    public void act() {
        if(Greenfoot.isKeyDown("space") && getObjects(menu.class).isEmpty()) 
        addObject(Menu, 100, 419);
        if(timer.getValue() >= 60) {
            finished = true;
            return;
        }
        if(tick > 40) {
            timer.setValue(timer.getValue()+1);
            tick = 0;
        }
        tick++;
    }
    
    public static Color getRandomColor() {
        return new Color(Greenfoot.getRandomNumber(255), Greenfoot.getRandomNumber(255), Greenfoot.getRandomNumber(255));
    }
}